<?php
/*
  $Id: tax_below_price.php
  $Loc: catalog/includes/modules/store/

  show tax below price 4.5 Phoenix Cart
  by @raiwa
  info@oscaddons.com.com
  www.oscaddons.com

  Original version:
  By www.tim-international.net

  Copyright (c) 2021 Rainer Schmied

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Copyright (c) 2021 Phoenix Cart

  Released under the GNU General Public License
*/

  class st_tax_below_price extends abstract_executable_module {

    public $parameters;

    const CONFIG_KEY_BASE = 'MODULE_STORE_TAX_BELOW_PRICE_';

    public function __construct() {
      parent::__construct(__FILE__);

      $this->description .= '<p>by @raiwa <u><a target="_blank" href="http://www.oscaddons.com">www.oscaddons.com</a></u></p>';
      if (!file_exists(DIR_FS_CATALOG . 'templates/' . TEMPLATE_SELECTION . '/includes/hooks/shop/siteWide/priceTax.php')) {
        $this->enabled = false;
        $this->description = '<div class="alert alert-danger" role="alert">' .
                                 MODULE_STORE_TAX_BELOW_PRICE_HOOK_WARNING .
                             '</div>' .
                             $this->description;
      }

    }

    function execute() {

      if (class_exists('currencies_mod')) {

        $GLOBALS['Template']->add_block('<style> td .taxinfo { text-align: right; } del .taxinfo { display: none; } .caption .taxinfo { margin-top: -10px; } .btn .taxinfo { margin-top: 0px; } .productPrice .taxinfo, h2 .taxinfo { font-size: 0.4em !important; padding-top; 0;}</style>' . "\n", 'header_tags');

        // remove tags from options menu
        if ( substr(basename(Request::get_page()), 0, 7) == 'product' ) { // add script only on product pages
          $GLOBALS['Template']->add_block('<script>
$("option").each(function () {
$(this).text($(this).text().replace(\'<div class="taxinfo"><small>\',\' \'));
$(this).text($(this).text().replace(\'</small></div>\',\'\'));
});
</script>', 'footer_scripts');
        } // end remove tags from options menu
      } // end if currencies_mod class exists
    }

    protected function get_parameters() {
      return [
        'MODULE_STORE_TAX_BELOW_PRICE_VERSION_INSTALLED' => [
          'title' => 'Current Version',
          'value' => '4.5',
          'desc' => 'Version info. It is read only',
          'set_func' => 'st_tax_below_price::readonly(',
        ],
        'MODULE_STORE_TAX_BELOW_PRICE_STATUS' => [
          'title' => 'Enable Tax Below Price Module',
          'value' => 'True',
          'desc' => 'Do you want to enable the Tax Below Price Module?',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_STORE_TAX_BELOW_PRICE_DISPLAY_TAX_VALUE' => [
          'title' => 'Display tax amount',
          'value' => 'True',
          'desc' => 'Do you wants to include the tax amount?',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_STORE_TAX_BELOW_PRICE_PAGES' => [
          'title' => 'Pages',
          'value' => implode(';', st_tax_below_price::get_default_pages()),
          'desc' => 'The pages to add the jQuery Scripts to.',
          'use_func' => 'page_selection::_show_pages',
          'set_func' => 'page_selection::_edit_pages(',
        ],
      ];
    }

    public static function readonly($value) {
      return $value;
    }

    public static function get_default_pages() {

    	$exclude_array =  ['checkout_process.php',
                         'download.php',
                         'redirect.php',
                         'ssl_check.php'];
    	$file_extension = substr(Request::get_page(), strrpos(Request::get_page(), '.'));
    	$files_array = [];
    	if ($dir = @dir(DIR_FS_CATALOG)) {
    		while ($file = $dir->read()) {
    			if ( !is_dir(DIR_FS_CATALOG . $file) && !in_array($file, $exclude_array) ) {
    				if (substr($file, strrpos($file, '.')) == $file_extension) {
    					$files_array[] = $file;
    				}
    			}
    		}
        if ($dir = @dir(DIR_FS_CATALOG . 'ext/modules/content/reviews/')) {
          while ($file = $dir->read()) {
            if ( !is_dir(DIR_FS_CATALOG . $file) && !in_array($file, $exclude_array) ) {
              if (substr($file, strrpos($file, '.')) == $file_extension) {
                $files_array[] = $file;
              }
            }
          }
        }

    		sort($files_array);
    		$dir->close();
    		return $files_array;
    	}
    }

  }
