<?php
/*
  show tax below price 4.5 Phoenix Cart

  Original version:
  By www.tim-international.net

  Copyright (c) 2021 Rainer Schmied

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Copyright (c) 2021 Phoenix Cart

  Released under the GNU General Public License
*/

class hook_shop_siteWide_priceTax {

  public $version = '4.5';

  function listen_injectAppTop() {

    if ( defined('MODULE_STORE_TAX_BELOW_PRICE_PAGES') && !Text::is_empty(MODULE_STORE_TAX_BELOW_PRICE_PAGES)) {
      $pages_array = [];

      foreach (explode(';', MODULE_STORE_TAX_BELOW_PRICE_PAGES) as $page) {
        $page = trim($page);

        if (!empty($page)) {
          $pages_array[] = $page;
        }
      }

      if (in_array(basename(Request::get_page()), $pages_array)) { // register only if page is selected
        $GLOBALS['currencies'] = new currencies_mod();

      }
    }

  }

}

  if (class_exists('currencies')) {
    class currencies_mod extends currencies {
    	// add tax below price mod
    	public function format($number, $calculate_currency_value = true, $currency_type = null, $currency_value = null, $products_tax = '', $show_tax_info = true) {
        if (empty($currency_type)) {
          $currency_type = $_SESSION['currency'] ?? DEFAULT_CURRENCY;
        }

        if ($calculate_currency_value) {
          $number *= ($currency_value ?? $this->currencies[$currency_type]['value']);
        }

        $format_string = $this->currencies[$currency_type]['symbol_left']
                       . number_format(
                           static::round($number, $this->currencies[$currency_type]['decimal_places']),
                           $this->currencies[$currency_type]['decimal_places'],
                           $this->currencies[$currency_type]['decimal_point'],
                           $this->currencies[$currency_type]['thousands_point'])
                       . $this->currencies[$currency_type]['symbol_right'];

    		if ( defined('MODULE_STORE_TAX_BELOW_PRICE_STATUS') && MODULE_STORE_TAX_BELOW_PRICE_STATUS == 'True' && $show_tax_info == true && $number > 0 && $products_tax !== '' ) {
    			$format_string .= '<div class="taxinfo"><small>';
    			if ( $products_tax == '0' || DISPLAY_PRICE_WITH_TAX == 'false' ) {
    				$format_string .= TAX_BELOW_PRICE_EXCLUDING_TAX;
    			} else {
    				if ( MODULE_STORE_TAX_BELOW_PRICE_DISPLAY_TAX_VALUE == 'True' ) {
    					$format_string .= sprintf(TAX_BELOW_PRICE_INCLUDING_TAX_AMOUNT, $products_tax, null);
    				} else {
    					$format_string .= TAX_BELOW_PRICE_INCLUDING_TAX_TEXTONLY;
    				}
    			}
    			$format_string.= '</small></div>';
    		}
    		return $format_string;
    	}

      public function calculate_price($products_price, $products_tax, $quantity = 1) {
        return static::round(Tax::price($products_price, $products_tax), $this->currencies[$_SESSION['currency'] ?? DEFAULT_CURRENCY]['decimal_places']) * $quantity;
      }

    	// add tax below price mod
      public function display_price($products_price, $products_tax, $quantity = 1, $show_tax_info = true) {
      	return $this->format($this->calculate_price($products_price, $products_tax, $quantity), true, null, null, $products_tax, $show_tax_info);
      }
    } // end class currencies mod
  } // end if class exists
